---
title: "Programmation séquentielle"
subtitle: "Série 3 -  Estimation de la valeur de pi"
date: 27.09.2022
---

# Buts

- Utilisation de boucles, tests et nombres aléatoires

# Estimation de $\pi$ à l'aide de séries numériques

Ecrire un programme qui calcule différentes approximations de la valeur de $\pi$ en vous servant des formules
ci-dessous. La constante `M_PI` est déclaré dans le header `<math.h>`, utiliser cette valeur comme référence pour estimer l'erreur
dans les approximations.

## Formules

\begin{equation} 
\sum_{n=1}^{\infty} {1 \over {n^4}} = {\pi^4 \over 90}
\end{equation}

\begin{equation} 
\sum_{n=1}^{\infty} {{(-1)^{n+1}} \over {n^2}} = {\pi^2 \over 12}
\end{equation}

\begin{equation}
\prod_{n=1}^{\infty} \left( {2n \over {2n-1}} \right) \left( {2n \over {2n+1}} \right) = {\pi \over 2}
\end{equation}

Pour exécuter votre programme, vous aurez besoin de la librairie `math` :

 `#include <math.h>` et compiler avec l'option `-lm`.

Vous aurez également besoin des fonctions `pow` et `sqrt`. Utiliser `man 3 pow` et `man 3 sqrt` pour obtenir la documentation de ces fonctions.

# Partie bonus

Cette partie n'est pas obligatoire. Vous pouvez la faire si vous souhaitez aller plus loin.

## Estimation de $\pi$ par la méthode de Monte-Carlo

Considérons le carré $C = [-1, 1] x [-1, 1]$. Si on tire une probabilité uniforme un point (x, y), quelle est la
probabilité que ce point tombe dans le disque $D$ de rayon 1 centré en (0, 0) ? Cette probabilité est en fait
égale au rapport de l’aire du disque sur l’aire du carré.

En effectuant $N$ tirages et en comptabilisant la variable $cpt$ de fois pour laquelle le point tombe dans $D$, le
rapport $cpt/N$ donne une estimation de la probabilité de tomber dans le disque et donc du rapport de l’aire
du disque sur l’aire du carré. Si vous faites un dessein vous vous apercevrez que $cpt/N \rightarrow \pi/4$. Cette
estimation est d’autant meilleure que N est grand. Pour déterminer si un point tiré aléatoirement est dans le
disque $D$ pensez au théorème de Pythagore. Utilisez l'exemple de la série 2 pour générer des nombres aléatoires.