#include <stdio.h>
#include <stdlib.h>

// le tableau statique tab[a] est désalloué à la fin de la fonction
// on le remplace par une allocation dynamique
int *foo(int a) {
    int* tab = malloc(a*sizeof(int));
    for (int i = 0; i < a; ++i) {
        tab[i] = 2;
    }
    return tab;
}

// l'allocation était de a octets au lieu de a*sizeof(int) octets
int *bar(int a) {
    int *tab = malloc(a*sizeof(int));
    for (int i = 0; i < a; ++i) {
        tab[i] = 2;
    }
    return tab;
}

// tab était réalloué à l'intérieu de baz sans que cela soit visible a l'exterieur
// cela a pour conséquence de ne pas initialiser l'espace mémoire vu a l'extérieur
// et de provoquer une fuite mémoire
void baz(int *tab, int b) {
    for (int i = 0; i < b; ++i) {
        tab[i] = 2;
    }
}

int main() {
    int *a = foo(4);
    printf("%d\n", a[3]);

    int *b = bar(4);
    printf("%d\n", b[3]);

    int *c = malloc(4*sizeof(int));
    baz(c, 4);
    printf("%d\n", c[3]);

    free(a);
    free(b);
    free(c);
}