#include <stdlib.h>
#include <stdbool.h>
#include <stdio.h>
#include <string.h>

typedef struct element_{
    char* data;
    struct element_* prev;
    struct element_* next;
}element;

typedef struct dll_{
    element* head;
    element* cur;
}dll;


// === Création et consultation ===
// crée la liste doublement chaînée
dll dll_create();
// retourne la valeur à la position actuelle dans la liste
char* dll_value(dll list);
// la liste est-elle vide?
bool dll_is_empty(dll list);
// Est-ce que cur est le 1er élément?
bool dll_is_head(dll list);
// Est-ce que cur est le dernier élément?
bool dll_is_tail(dll list);
// data est-elle dans la liste?
bool dll_is_present(dll list, char* data);
// affiche la liste
void dll_print(dll list);

// === Manipulation ===
// déplace cur au début de la liste
dll dll_move_to_head(dll list);
// déplace cur à la position suivante dans la liste
dll dll_next(dll list);
// déplace cur à la position précédente dans la liste
dll dll_prev(dll list);

// === Insertion ===
// insertion de data dans l'élément après cur
dll dll_insert_after(dll list, char* data);
// insertion de data en tête de liste
dll dll_push(dll list, char* data);

// === Extraction === 
// extraction de la valeur se trouvant dans l'élément cur
// l'élément cur est libéré (mais pas la chaine de caractères)
char* dll_extract(dll *list);
// extrait la donnée en tête de liste
// l'élément en tête est libéré (mais pas la chaine de caractères)
char* dll_pop(dll *list);
// vide la liste (les chaines de caractères sont libérées)
void dll_destroy(dll *list);
